#include <call_kernel.h>
//pass
//--blockDim=1024 --gridDim=1
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <cuda.h>
#include <cuda_runtime_api.h>
#define N 4//1024

//swap the strings
__device__ void swap(char *in, char *out) {
	char tmp[N];
	tmp[threadIdx.x]= in[threadIdx.x];
	__syncthreads();
	in[threadIdx.x] = out[threadIdx.x];
	__syncthreads();
	out[threadIdx.x]= tmp[threadIdx.x];
}

__global__ void foo(char *A, char *B, char* c)
{
  char *choice1 = A;	//It Makes choice1 receives A
  char *choice2 = B;	//It Makes choice2 receives B
  swap(choice1, choice2);		//This function swaps choice1 and choice2
}

int main() {

	char *a;
	char *d;
	char *dev_a;
	char *b;
	char *e;
	char *dev_b;
	char c = 'x';
	char* dev_c;
	int size = N*sizeof(char);

	cudaMalloc((void**)&dev_a, size);
	cudaMalloc((void**)&dev_b, size);
	cudaMalloc((void**)&dev_c, sizeof(char));

	a = (char*)malloc(size);
	d = (char*)malloc(size);
	b = (char*)malloc(size);
	e = (char*)malloc(size);

	strcpy(a, "123");
	strcpy(b, "123");

	cudaMemcpy(dev_a,a,size, cudaMemcpyHostToDevice);
	cudaMemcpy(dev_b,b,size, cudaMemcpyHostToDevice);
	cudaMemcpy(dev_c,&c,sizeof(char), cudaMemcpyHostToDevice);

	printf("\nOn CPU: \n");
	printf(a); printf("\n");
	printf(b); printf("\n");

	printf("\nOn GPU:\n");
	//foo<<<1,N>>>(dev_a, dev_b, dev_c);
	ESBMC_verify_kernel(foo, 1, N, dev_a, dev_b, dev_c);
	printf("\n");
	cudaMemcpy(d,dev_a,size,cudaMemcpyDeviceToHost);
	cudaMemcpy(e,dev_b,size,cudaMemcpyDeviceToHost);

	printf(d); printf("\n");
	printf(e); printf("\n");

	assert(!(!((strcmp(a,e))or(strcmp(b,d)))));

	free(a); free(d);	free(b); free(e);

	cudaFree(dev_a);
	cudaFree(dev_b);

	return 0;
}
